//+------------------------------------------------------------------+
//|                                             OBJ_BITMAP_LABEL.mq5 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//--- 
#property description "   \" \"."
//---       
#property script_show_inputs
//---   
input string            InpName="BmpLabel";               //  
input string            InpFileOn="candles_on_80.bmp"; //     On
input string            InpFileOff="candles_off_80.bmp";  //     Off
input bool              InpState=false;                   //  /
input ENUM_BASE_CORNER  InpCorner=CORNER_LEFT_UPPER;      //    
input ENUM_ANCHOR_POINT InpAnchor=ANCHOR_CENTER;          //  
input color             InpColor=clrRed;                  //    
input ENUM_LINE_STYLE   InpStyle=STYLE_SOLID;             //    
input int               InpPointWidth=1;                  //    
input bool              InpBack=false;                    //    
input bool              InpSelection=false;               //   
input bool              InpHidden=true;                   //    
input long              InpZOrder=0;                      //    
//+------------------------------------------------------------------+
//|   " "                               |
//+------------------------------------------------------------------+
bool BitmapLabelCreate(const long              chart_ID=0,               // ID 
                       const string            name="BmpLabel",          //  
                       const int               sub_window=0,             //  
                       const int               x=0,                      //    X
                       const int               y=0,                      //    Y
                       const string            file_on="",               //    On
                       const string            file_off="",              //    Off
                       const int               width=0,                  // X-  
                       const int               height=0,                 // Y-  
                       const int               x_offset=10,              //     X
                       const int               y_offset=10,              //     Y
                       const bool              state=false,              // /
                       const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                       const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //   
                       const color             clr=clrRed,               //    
                       const ENUM_LINE_STYLE   style=STYLE_SOLID,        //    
                       const int               point_width=1,            //   
                       const bool              back=false,               //   
                       const bool              selection=false,          //   
                       const bool              hidden=true,              //    
                       const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_BITMAP_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ":     \" \"!   = ",GetLastError());
      return(false);
     }
//---     On  Off
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,0,file_on))
     {
      Print(__FUNCTION__,
            ":       On!   = ",GetLastError());
      return(false);
     }
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,1,file_off))
     {
      Print(__FUNCTION__,
            ":       Off!   = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---    ;     
//---      ()  , 
//---   ;        ,
//---     ,    
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//--- ,        
//---       ;  
//---          
   ObjectSetInteger(chart_ID,name,OBJPROP_XOFFSET,x_offset);
   ObjectSetInteger(chart_ID,name,OBJPROP_YOFFSET,y_offset);
//--- ,      (  )
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---        
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,point_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,clrRed);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|      " "     |
//+------------------------------------------------------------------+
bool BitmapLabelSetImage(const long   chart_ID=0,      // ID 
                         const string name="BmpLabel", //  
                         const int    on_off=0,        //  (On  Off)
                         const string file="")         //   
  {
//---   
   ResetLastError();
//---      
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,on_off,file))
     {
      Print(__FUNCTION__,
            ":    !   = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|   " "                            |
//+------------------------------------------------------------------+
bool BitmapLabelMove(const long   chart_ID=0,      // ID 
                     const string name="BmpLabel", //  
                     const int    x=0,             //    X
                     const int    y=0)             //    Y
  {
//---   
   ResetLastError();
//---  
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x))
     {
      Print(__FUNCTION__,
            ":    X- !   = ",GetLastError());
      return(false);
     }
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y))
     {
      Print(__FUNCTION__,
            ":    Y- !   = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|     ( )               |
//+------------------------------------------------------------------+
bool BitmapLabelChangeSize(const long   chart_ID=0,      // ID 
                           const string name="BmpLabel", //  
                           const int    width=0,         //  
                           const int    height=0)        //  
  {
//---   
   ResetLastError();
//---   
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width))
     {
      Print(__FUNCTION__,
            ":     !   = ",GetLastError());
      return(false);
     }
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height))
     {
      Print(__FUNCTION__,
            ":     !   = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|              |
//+------------------------------------------------------------------+
bool BitmapLabelMoveVisibleArea(const long   chart_ID=0,      // ID 
                                const string name="BmpLabel", //  
                                const int    x_offset=0,      //  X  
                                const int    y_offset=0)      //  Y  
  {
//---   
   ResetLastError();
//---     
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_XOFFSET,x_offset))
     {
      Print(__FUNCTION__,
            ":    X-  !   = ",GetLastError());
      return(false);
     }
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_YOFFSET,y_offset))
     {
      Print(__FUNCTION__,
            ":    Y-  !   = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|   " "                               |
//+------------------------------------------------------------------+
bool BitmapLabelDelete(const long   chart_ID=0,      // ID 
                       const string name="BmpLabel") //  
  {
//---   
   ResetLastError();
//---  
   if(!ObjectDelete(chart_ID,name))
     {
      Print(__FUNCTION__,
            ":     \" \"!   = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---   
   long x_distance;
   long y_distance;
//---   
   if(!ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0,x_distance))
     {
      Print("    !   = ",GetLastError());
      return;
     }
   if(!ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0,y_distance))
     {
      Print("    !   = ",GetLastError());
      return;
     }
//---    
   int x=(int)x_distance/2;
   int y=(int)y_distance/2;
//---       
   int width=80;
   int height=80;
   int x_offset=0;
   int y_offset=0;
//---      
   if(!BitmapLabelCreate(0,InpName,0,x,y,InpFileOn,InpFileOff,width,height,x_offset,y_offset,InpState,
      InpCorner,InpAnchor,InpColor,InpStyle,InpPointWidth,InpBack,InpSelection,InpHidden,InpZOrder))
     {
      return;
     }
//---      
   ChartRedraw();
   Sleep(1000);
//---       
   for(int i=0;i<6;i++)
     {
      //---    
      width--;
      height--;
      if(!BitmapLabelChangeSize(0,InpName,width,height))
         return;
      //---     
      if(IsStopped())
         return;
      //---  
      ChartRedraw();
      //   0.3 
      Sleep(300);
     }
//---   1 
   Sleep(1000);
//---       
   for(int i=0;i<2;i++)
     {
      //---    
      x_offset++;
      y_offset++;
      if(!BitmapLabelMoveVisibleArea(0,InpName,x_offset,y_offset))
         return;
      //---     
      if(IsStopped())
         return;
      //---  
      ChartRedraw();
      //   0.3 
      Sleep(300);
     }
//---   1 
   Sleep(1000);
//---  
   BitmapLabelDelete(0,InpName);
   ChartRedraw();
//---   1 
   Sleep(1000);
//---
  }
